"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _formData = _interopRequireDefault(require("form-data"));

var _fs = require("fs");

var _nodeToolkit = require("@tech_query/node-toolkit");

/**
 * @external {Context} https://github.com/koajs/koa/blob/master/docs/api/context.md
 */

/**
 * @param {Context} context
 *
 * @return {FormData|Object|string}
 */
function buildData(context) {
  if (/^Head|Get|Delete$/.test(context.method)) return '';
  var request = context.request;
  if (request.type !== 'multipart/form-data') return request.body;
  var form = new _formData.default();

  for (var key in request.fields) {
    form.append(key, request.fields[key]);
  }

  for (var _key in request.files) {
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = request.files[_key][Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var file = _step.value;
        form.append(_key, (0, _fs.createReadStream)(file.path), file.name);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  }

  return form;
}
/**
 * @param {string}  URL
 * @param {Context} context
 *
 * @return {IncomingMessage}
 */


function pipe(_x, _x2) {
  return _pipe.apply(this, arguments);
}
/**
 * @param {Object} proxyMap
 *
 * @return {AsyncFunction} Koa middleware
 */


function _pipe() {
  _pipe = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee2(URL, context) {
    var header, response, key;
    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            header = Object.assign({}, context.header);
            delete header.host;
            _context2.next = 4;
            return (0, _nodeToolkit.request)(URL, context.method, header, buildData(context));

          case 4:
            response = _context2.sent;
            context.status = response.statusCode, context.message = response.statusMessage;

            for (key in response.headers) {
              if (key !== 'status') context.set(key.replace(/^\w|-\w/g, function (char) {
                return char.toUpperCase();
              }), response.headers[key]);
            }

            return _context2.abrupt("return", context.body = response);

          case 8:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));
  return _pipe.apply(this, arguments);
}

function _default(proxyMap) {
  /**
   * @param {Context}  context
   * @param {Function} next
   *
   * @return {?IncomingMessage}
   */
  return (
    /*#__PURE__*/
    function () {
      var _ref = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(context, next) {
        var URL, path, final;
        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                URL = context.path + context.request.search;
                _context.t0 = _regenerator.default.keys(proxyMap);

              case 2:
                if ((_context.t1 = _context.t0()).done) {
                  _context.next = 9;
                  break;
                }

                path = _context.t1.value;
                final = URL.replace(proxyMap[path], path);

                if (!(final !== URL)) {
                  _context.next = 7;
                  break;
                }

                return _context.abrupt("return", pipe(final, context));

              case 7:
                _context.next = 2;
                break;

              case 9:
                _context.next = 11;
                return next();

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x3, _x4) {
        return _ref.apply(this, arguments);
      };
    }()
  );
}
//# sourceMappingURL=ProxyAgent.js.map